pipeline {
  agent any
  options {
    gitLabConnection 'gitlab'
  } 
  tools {
    maven "maven384"
    jdk "jdk11"
  }
    stages {
      stage('Test') {
        steps {
          updateGitlabCommitStatus name: 'test', state: 'pending'
          sh 'mvn -e clean test'
          updateGitlabCommitStatus name: 'test', state: 'success'
        }
      }
      stage('SonarQube Analysis') {
        steps {
          withSonarQubeEnv('sonarqube') {
            updateGitlabCommitStatus name: 'test', state: 'pending'
            sh "mvn clean verify sonar:sonar -Dsonar.projectKey=mspr-jenkins2"
            updateGitlabCommitStatus name: 'test', state: 'success'
          }
        }
      }
      stage('Build') {
        steps {
          updateGitlabCommitStatus name: 'build', state: 'pending'
          sh 'mvn -e clean assembly:assembly -DdescriptorId=jar-with-dependencies'
          updateGitlabCommitStatus name: 'build', state: 'success'
        }
      }
      stage('generation') {
        steps {
          updateGitlabCommitStatus name: 'generation', state: 'pending'
          sh 'java -jar target/gosecuri-1-jar-with-dependencies.jar'
          updateGitlabCommitStatus name: 'generation', state: 'success'
        }
      }
      stage('send'){
        steps {
          updateGitlabCommitStatus name: 'send', state: 'pending'
          sh 'scp -o StrictHostKeyChecking=no -r output/* root@webserver.mspr.kyabe-sama.fr:/root/output'
          updateGitlabCommitStatus name: 'send', state: 'success'
        }
      }
    }
  
}